apeman-infr
==========

<!---
This file is generated by ape-tmpl. Do not update manually.
--->

<!-- Badge Start -->
<a name="badges"></a>

[![Build Status][bd_travis_shield_url]][bd_travis_url]
[![Code Climate][bd_codeclimate_shield_url]][bd_codeclimate_url]
[![Code Coverage][bd_codeclimate_coverage_shield_url]][bd_codeclimate_url]
[![npm Version][bd_npm_shield_url]][bd_npm_url]

[bd_repo_url]: https://github.com/apeman-cmd-labo/apeman-infr
[bd_travis_url]: http://travis-ci.org/apeman-cmd-labo/apeman-infr
[bd_travis_shield_url]: http://img.shields.io/travis/apeman-cmd-labo/apeman-infr.svg?style=flat
[bd_license_url]: https://github.com/apeman-cmd-labo/apeman-infr/blob/master/LICENSE
[bd_codeclimate_url]: http://codeclimate.com/github/apeman-cmd-labo/apeman-infr
[bd_codeclimate_shield_url]: http://img.shields.io/codeclimate/github/apeman-cmd-labo/apeman-infr.svg?style=flat
[bd_codeclimate_coverage_shield_url]: http://img.shields.io/codeclimate/coverage/github/apeman-cmd-labo/apeman-infr.svg?style=flat
[bd_gemnasium_url]: https://gemnasium.com/apeman-cmd-labo/apeman-infr
[bd_gemnasium_shield_url]: https://gemnasium.com/apeman-cmd-labo/apeman-infr.svg
[bd_npm_url]: http://www.npmjs.org/package/apeman-infr
[bd_npm_shield_url]: http://img.shields.io/npm/v/apeman-infr.svg?style=flat
[bd_bower_badge_url]: https://img.shields.io/bower/v/apeman-infr.svg?style=flat

<!-- Badge End -->


<!-- Description Start -->
<a name="description"></a>

Infrastructure manager for apeman.

<!-- Description End -->


<!-- Overview Start -->
<a name="overview"></a>

apeman-infr command enables you to setup infrastructure using [docker](https://www.docker.com/)



<!-- Overview End -->


<!-- Sections Start -->
<a name="sections"></a>

<!-- Section from "doc/guides/01.Installation.md.hbs" Start -->

<a name="section-doc-guides-01-installation-md"></a>
Installation
-----

Install apeman-infr module via [npm][npm_url].
```bash
$ npm install apeman-infr -g
```


[npm_url]: https://www.npmjs.com/


<!-- Section from "doc/guides/01.Installation.md.hbs" End -->

<!-- Section from "doc/guides/02.Usage.md.hbs" Start -->

<a name="section-doc-guides-02-usage-md"></a>
Usage
---------

1. Prepare an Apemanfile.js at your project root.
2. Run the command via CLI.

***Apemanfile.js***
```javascript
/** Example of Apemanfile.js */

"use strict";

module.exports = {
    $cwd: __dirname,
    $pkg: {/*...*/},
    $proto: [/*...*/],
    $tmpls: {/*...*/},
    $tasks: {/*...*/},
    $apps: {/*...*/},
    $wtchs: {/*...*/},
    $infrs: {
        'my-node-01': './infra/node/Dockerfile' // Path infra docker path.
    }
};

```

Then,

```bash
$ apeman-infr
```


##### CLI Options

```bash
$ apeman-infr -h

  Usage: apeman-infr [options] 

  Infrastructure manager for apeman.

  Options:

    -h, --help                           output usage information
    -V, --version                        output the version number
    -v, --verbose                        Show verbose logs
    -p, --pattern <pattern>              Watch name pattern
    -f, --force                          Force to remove image.
    -d, --delete                         Remove image.
    -c, --configuration <configuration>  Pathname of Apemanfile
    -l, --list                           List available watches

  Examples:

    $ apeman-infr     # Build all infra defined in $infrs prop.
    $ apeman-infr -l     # List available infra.
    $ apeman-infr -p node*     # Build infra which match pattern.
    $ apeman-infr -d     # Remove all infra defined in $infrs prop.


```


<!-- Section from "doc/guides/02.Usage.md.hbs" End -->

<!-- Section from "doc/guides/03.Programmatic API.md.hbs" Start -->

<a name="section-doc-guides-03-programmatic-a-p-i-md"></a>
Programmatic API
---

apeman-infr also provide programmatic API.

Firstly, install the module locally.

```bash
$ npm install apeman-infr --save-dev
```

Then,

```javascript
"use strict";

const apemanInfr = require('apeman-infr');

apemanInfr({
    pattern: 'my-node-01',
    force: false
}, (err) => {
    /*...*/
});
```


##### Programmatic Options

| Key | Description | Default |
| --- | ----------- | ------- |
| verbose | Show verbose logs |  |
| pattern | Watch name pattern |  |
| force | Force to remove image. |  |
| delete | Remove image. |  |
| configuration | Pathname of Apemanfile |  |
| list | List available watches |  |


<!-- Section from "doc/guides/03.Programmatic API.md.hbs" End -->


<!-- Sections Start -->


<!-- LICENSE Start -->
<a name="license"></a>

License
-------
This software is released under the [MIT License](https://github.com/apeman-cmd-labo/apeman-infr/blob/master/LICENSE).

<!-- LICENSE End -->


<!-- Links Start -->
<a name="links"></a>

Links
------

+ [apeman](http://github.com/apeman-labo/apeman)
+ [apeman-cmd-labo](http://github.com/apeman-cmd-labo)
+ [docker](https://www.docker.com/)

<!-- Links End -->
