/**
 * @function buildInfrs
 */

"use strict";

const argx = require('argx'),
    async = require('async'),
    apemandocker = require('apemandocker'),
    getInfrs = require('./get_infrs');

/** @lends buildInfrs */
function buildInfrs(apemanfile, options, callback) {
    let args = argx(arguments);
    callback = args.pop('function') || argx.noop;
    options = args.pop('object') || {};

    let docker = apemandocker.create(),
        infra = getInfrs(apemanfile, options.pattern);

    async.eachSeries([].concat(infra), (infra, callback) => {
        docker.buildImage(infra.src, {
            tag: infra.tag
        }, callback);
    }, callback);
}

module.exports = buildInfrs;
