/**
 * @constructor Infra
 */

"use strict";

const path = require('path'),
    extend = require('extend');

/** @lends Infra */
function Infra(src, params) {
    let s = this;
    if (!src) {
        throw new Error('[apeman-infr] image is required.');
    }
    s.setSrc(src);
    s.setParams(params);
}

Infra.prototype = {
    image: null,
    params: null,
    setParams: function (params) {
        let s = this;
        extend(s, params);
    },
    setSrc: function (src) {
        let s = this;
        var isFullpath = path.basename(src).trim() === 'Dockerfile';
        if (isFullpath) {
            src = path.dirname(src);
        }
        s.src = path.resolve(src);
    }
};

Infra.new = function (conf) {
    return new Infra(conf);
};


module.exports = Infra;
