/**
 * @function listInfrs
 */

"use strict";

const argx = require('argx'),
    extend = require('extend'),
    apemandocker = require('apemandocker'),
    getInfrs = require('./get_infrs'),
    ListLogger = require('../logging/list_logger');

/** @lends listInfrs */
function listInfrs(apemanfile, options, callback) {
    let args = argx(arguments);
    callback = args.pop('function') || argx.noop;
    options = args.pop('object') || {};

    let docker = apemandocker.create(),
        logger = new ListLogger({}),
        infra = getInfrs(apemanfile, options.pattern);

    logger.logList(infra);
    callback(null);
}

module.exports = listInfrs;