/**
 * @function removeInfrs
 */

"use strict";

const argx = require('argx'),
    async = require('async'),
    apemandocker = require('apemandocker'),
    getInfrs = require('./get_infrs');

/** @lends removeInfrs */
function removeInfrs(apemanfile, options, callback) {
    let args = argx(arguments);
    callback = args.pop('function') || argx.noop;
    options = args.pop('object') || {};

    let docker = apemandocker.create(),
        infra = getInfrs(apemanfile, options.pattern);

    async.eachSeries([].concat(infra), (infra, callback) => {
        docker.removeImage(infra.tag, {
            force: !!options.force
        }, callback);
    }, callback);
}

module.exports = removeInfrs;
