/**
 * Logger for list.
 * @constructor ListLogger
 */

"use strict";

const colorprint = require('colorprint'),
    path = require('path'),
    colors = colorprint.colors,
    textconv = require('textconv');

const NAME_MIN_LENGTH = 24;

/** @lends ListLogger */
module.exports = colorprint.define(
    /** @lends ListLogger.prototype */
    {
        /**
         * Log infra list.
         * @param {object} infra - Infra to show.
         */
        logList: function (infra) {
            let s = this;
            s.debug('');
            s.debug('  Available infra:');
            s.debug('');
            [].concat(infra || {}).forEach((infra) => {
                let src = path.resolve(infra.src);
                s.debug(`    ${colors.black.bold(textconv.pad(infra.name, NAME_MIN_LENGTH))}\t ${colors.blackBright(src)}`);
            });
            s.debug('');
        }
    }
);
